# Copyright (c) 2019 William ML Leslie

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

from entangled.python.config.base import Config
config = Config('CPython', 2, 6)
config.define( 23, "BINARY_ADD")
config.define( 64, "BINARY_AND")
config.define( 21, "BINARY_DIVIDE")
config.define( 26, "BINARY_FLOOR_DIVIDE")
config.define( 62, "BINARY_LSHIFT")
config.define( 22, "BINARY_MODULO")
config.define( 20, "BINARY_MULTIPLY")
config.define( 66, "BINARY_OR")
config.define( 19, "BINARY_POWER")
config.define( 63, "BINARY_RSHIFT")
config.define( 25, "BINARY_SUBSCR")
config.define( 24, "BINARY_SUBTRACT")
config.define( 27, "BINARY_TRUE_DIVIDE")
config.define( 65, "BINARY_XOR")
config.define( 80, "BREAK_LOOP", ['no_return'], [config.MAY_BREAK])
config.define( 89, "BUILD_CLASS")
config.define(103, "BUILD_LIST", ['oparg'])
config.define(104, "BUILD_MAP", ['oparg'])
config.define(133, "BUILD_SLICE", ['oparg'])
config.define(102, "BUILD_TUPLE", ['oparg'])
config.define(131, "CALL_FUNCTION", ['oparg'])
config.define(141, "CALL_FUNCTION_KW", ['oparg'])
config.define(140, "CALL_FUNCTION_VAR", ['oparg'])
config.define(142, "CALL_FUNCTION_VAR_KW", ['oparg'])
config.define(106, "COMPARE_OP", ['cmp'])
config.define(119, "CONTINUE_LOOP", ['jabs', 'no_return'])
config.define( 96, "DELETE_ATTR", ['name'])
config.define(126, "DELETE_FAST", ['local'])
config.define( 98, "DELETE_GLOBAL", ['name'])
config.define( 91, "DELETE_NAME", ['name'])
config.define( 50, "DELETE_SLICE+0")
config.define( 51, "DELETE_SLICE+1")
config.define( 52, "DELETE_SLICE+2")
config.define( 53, "DELETE_SLICE+3")
config.define( 61, "DELETE_SUBSCR")
config.define(  4, "DUP_TOP", [])
config.define( 99, "DUP_TOPX", ['oparg'], [])
config.define( 88, "END_FINALLY", ['pops_block']
               [config.MAY_RETURN, config.MAY_BREAK, config.MAY_RAISE])
config.define( 85, "EXEC_STMT",
               [config.MAY_RETURN, config.MAY_BREAK, config.MAY_RAISE])
config.define(143, "EXTENDED_ARG", ['oparg'], [])
config.define( 93, "FOR_ITER", ['jrel'], block_type=['loop'])
config.define( 68, "GET_ITER")
config.define(108, "IMPORT_FROM", ['name'])
config.define(107, "IMPORT_NAME", ['name'])
config.define( 84, "IMPORT_STAR")
config.define( 55, "INPLACE_ADD")
config.define( 77, "INPLACE_AND")
config.define( 58, "INPLACE_DIVIDE")
config.define( 28, "INPLACE_FLOOR_DIVIDE")
config.define( 75, "INPLACE_LSHIFT")
config.define( 59, "INPLACE_MODULO")
config.define( 57, "INPLACE_MULTIPLY")
config.define( 79, "INPLACE_OR")
config.define( 67, "INPLACE_POWER")
config.define( 76, "INPLACE_RSHIFT")
config.define( 56, "INPLACE_SUBTRACT")
config.define( 29, "INPLACE_TRUE_DIVIDE")
config.define( 78, "INPLACE_XOR")
config.define(113, "JUMP_ABSOLUTE", ['jabs', 'no_return'], [])
config.define(110, "JUMP_FORWARD", ['jrel', 'no_return'], [])
config.define(111, "JUMP_IF_FALSE", ['jrel'])
config.define(112, "JUMP_IF_TRUE", ['jrel'])
config.define( 18, "LIST_APPEND")
config.define(105, "LOAD_ATTR", ['name'])
config.define(135, "LOAD_CLOSURE", ['free'])
config.define(100, "LOAD_CONST", ['const'])
config.define(136, "LOAD_DEREF", ['free'])
config.define(124, "LOAD_FAST", ['local'])
config.define(116, "LOAD_GLOBAL", ['name'])
config.define( 82, "LOAD_LOCALS")
config.define(101, "LOAD_NAME", ['name'])
config.define(134, "MAKE_CLOSURE", ['oparg'])
config.define(132, "MAKE_FUNCTION", ['oparg'])
config.define(  9, "NOP", [], [])
config.define( 87, "POP_BLOCK", ['pops_block'])
config.define(  1, "POP_TOP", [], [])
config.define( 70, "PRINT_EXPR")
config.define( 71, "PRINT_ITEM")
config.define( 73, "PRINT_ITEM_TO")
config.define( 72, "PRINT_NEWLINE")
config.define( 74, "PRINT_NEWLINE_TO")
config.define(130, "RAISE_VARARGS", ['no_return', 'oparg'])
config.define( 83, "RETURN_VALUE", ['no_return'])
config.define(  5, "ROT_FOUR", [], [])
config.define(  3, "ROT_THREE", [], [])
config.define(  2, "ROT_TWO", [], [])
config.define(121, "SETUP_EXCEPT", ['jrel'], block_type=['except', 'restore'])
config.define(122, "SETUP_FINALLY", ['jrel'],
              block_type=['finally', 'restore'])
config.define(120, "SETUP_LOOP", ['jrel'], block_type=['loop'])
config.define( 30, "SLICE+0")
config.define( 31, "SLICE+1")
config.define( 32, "SLICE+2")
config.define( 33, "SLICE+3")
config.define(  0, "STOP_CODE", ['no_return'])
config.define( 95, "STORE_ATTR", ['name'])
config.define(137, "STORE_DEREF", ['free'])
config.define(125, "STORE_FAST", ['local'])
config.define( 97, "STORE_GLOBAL", ['name'])
config.define( 54, "STORE_MAP")
config.define( 90, "STORE_NAME", ['name'])
config.define( 40, "STORE_SLICE+0")
config.define( 41, "STORE_SLICE+1")
config.define( 42, "STORE_SLICE+2")
config.define( 43, "STORE_SLICE+3")
config.define( 60, "STORE_SUBSCR")
config.define( 13, "UNARY_CONVERT")
config.define( 15, "UNARY_INVERT")
config.define( 11, "UNARY_NEGATIVE")
config.define( 12, "UNARY_NOT")
config.define( 10, "UNARY_POSITIVE")
config.define( 92, "UNPACK_SEQUENCE", ['oparg'])
config.define( 81, "WITH_CLEANUP")
config.define( 86, "YIELD_VALUE")
