# Copyright (c) 2019 William ML Leslie

# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
# BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
# ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

from entangled.python.config.base import Config
config = Config('CPython', 3, 5)
config.define( 52, "BEFORE_ASYNC_WITH")
config.define( 23, "BINARY_ADD")
config.define( 64, "BINARY_AND")
config.define( 26, "BINARY_FLOOR_DIVIDE")
config.define( 62, "BINARY_LSHIFT")
config.define( 16, "BINARY_MATRIX_MULTIPLY")
config.define( 22, "BINARY_MODULO")
config.define( 20, "BINARY_MULTIPLY")
config.define( 66, "BINARY_OR")
config.define( 19, "BINARY_POWER")
config.define( 63, "BINARY_RSHIFT")
config.define( 25, "BINARY_SUBSCR")
config.define( 24, "BINARY_SUBTRACT")
config.define( 27, "BINARY_TRUE_DIVIDE")
config.define( 65, "BINARY_XOR")
config.define( 80, "BREAK_LOOP", ['no_return'])
config.define(103, "BUILD_LIST", ['oparg'])
config.define(149, "BUILD_LIST_UNPACK", ['oparg'])
config.define(105, "BUILD_MAP", ['oparg'])
config.define(150, "BUILD_MAP_UNPACK", ['oparg'])
config.define(151, "BUILD_MAP_UNPACK_WITH_CALL", ['oparg'])
config.define(104, "BUILD_SET", ['oparg'])
config.define(153, "BUILD_SET_UNPACK", ['oparg'])
config.define(133, "BUILD_SLICE", ['oparg'])
config.define(102, "BUILD_TUPLE", ['oparg'])
config.define(152, "BUILD_TUPLE_UNPACK", ['oparg'])
config.define(131, "CALL_FUNCTION", ['nargs'])
config.define(141, "CALL_FUNCTION_KW", ['nargs'])
config.define(140, "CALL_FUNCTION_VAR", ['nargs'])
config.define(142, "CALL_FUNCTION_VAR_KW", ['nargs'])
config.define(107, "COMPARE_OP", ['cmp'])
config.define(119, "CONTINUE_LOOP", ['jabs', 'no_return'])
config.define( 96, "DELETE_ATTR", ['name'])
config.define(138, "DELETE_DEREF", ['free'])
config.define(126, "DELETE_FAST", ['local'])
config.define( 98, "DELETE_GLOBAL", ['name'])
config.define( 91, "DELETE_NAME", ['name'])
config.define( 61, "DELETE_SUBSCR")
config.define(  4, "DUP_TOP")
config.define(  5, "DUP_TOP_TWO")
config.define( 88, "END_FINALLY")
config.define(144, "EXTENDED_ARG", ['oparg'])
config.define( 93, "FOR_ITER", ['jrel'])
config.define( 50, "GET_AITER")
config.define( 51, "GET_ANEXT")
config.define( 73, "GET_AWAITABLE")
config.define( 68, "GET_ITER")
config.define( 69, "GET_YIELD_FROM_ITER")
config.define(109, "IMPORT_FROM", ['name'])
config.define(108, "IMPORT_NAME", ['name'])
config.define( 84, "IMPORT_STAR")
config.define( 55, "INPLACE_ADD")
config.define( 77, "INPLACE_AND")
config.define( 28, "INPLACE_FLOOR_DIVIDE")
config.define( 75, "INPLACE_LSHIFT")
config.define( 17, "INPLACE_MATRIX_MULTIPLY")
config.define( 59, "INPLACE_MODULO")
config.define( 57, "INPLACE_MULTIPLY")
config.define( 79, "INPLACE_OR")
config.define( 67, "INPLACE_POWER")
config.define( 76, "INPLACE_RSHIFT")
config.define( 56, "INPLACE_SUBTRACT")
config.define( 29, "INPLACE_TRUE_DIVIDE")
config.define( 78, "INPLACE_XOR")
config.define(113, "JUMP_ABSOLUTE", ['jabs', 'no_return'])
config.define(110, "JUMP_FORWARD", ['jrel', 'no_return'])
config.define(111, "JUMP_IF_FALSE_OR_POP", ['jabs'])
config.define(112, "JUMP_IF_TRUE_OR_POP", ['jabs'])
config.define(145, "LIST_APPEND", ['oparg'])
config.define(106, "LOAD_ATTR", ['name'])
config.define( 71, "LOAD_BUILD_CLASS")
config.define(148, "LOAD_CLASSDEREF", ['free'])
config.define(135, "LOAD_CLOSURE", ['free'])
config.define(100, "LOAD_CONST", ['const'])
config.define(136, "LOAD_DEREF", ['free'])
config.define(124, "LOAD_FAST", ['local'])
config.define(116, "LOAD_GLOBAL", ['name'])
config.define(101, "LOAD_NAME", ['name'])
config.define(134, "MAKE_CLOSURE", ['oparg'])
config.define(132, "MAKE_FUNCTION", ['oparg'])
config.define(147, "MAP_ADD", ['oparg'])
config.define(  9, "NOP")
config.define( 87, "POP_BLOCK")
config.define( 89, "POP_EXCEPT")
config.define(114, "POP_JUMP_IF_FALSE", ['jabs'])
config.define(115, "POP_JUMP_IF_TRUE", ['jabs'])
config.define(  1, "POP_TOP")
config.define( 70, "PRINT_EXPR")
config.define(130, "RAISE_VARARGS", ['oparg', 'no_return'])
config.define( 83, "RETURN_VALUE", ['no_return'])
config.define(  3, "ROT_THREE")
config.define(  2, "ROT_TWO")
config.define(154, "SETUP_ASYNC_WITH", ['jrel'])
config.define(121, "SETUP_EXCEPT", ['jrel'])
config.define(122, "SETUP_FINALLY", ['jrel'])
config.define(120, "SETUP_LOOP", ['jrel'])
config.define(143, "SETUP_WITH", ['jrel'])
config.define(146, "SET_ADD", ['oparg'])
config.define( 95, "STORE_ATTR", ['name'])
config.define(137, "STORE_DEREF", ['free'])
config.define(125, "STORE_FAST", ['local'])
config.define( 97, "STORE_GLOBAL", ['name'])
config.define( 90, "STORE_NAME", ['name'])
config.define( 60, "STORE_SUBSCR")
config.define( 15, "UNARY_INVERT")
config.define( 11, "UNARY_NEGATIVE")
config.define( 12, "UNARY_NOT")
config.define( 10, "UNARY_POSITIVE")
config.define( 94, "UNPACK_EX", ['oparg'])
config.define( 92, "UNPACK_SEQUENCE", ['oparg'])
config.define( 82, "WITH_CLEANUP_FINISH")
config.define( 81, "WITH_CLEANUP_START")
config.define( 72, "YIELD_FROM")
config.define( 86, "YIELD_VALUE")
